! The module define the quantities read from the cube file as calculated by PW
!
! Author: 	Giacomo Miceli
!
module pwvar
	implicit none
	integer :: nat
	integer :: pwnx,pwny,pwnz
	integer, parameter :: npt=200 	! points for interpolation
	real :: f1(npt),f2(npt)			! interpolated averaged potentials
	real :: pwdx,pwdy,pwdz
	real, dimension (:,:,:), allocatable :: potch(:,:,:), potref(:,:,:)
end module
!
subroutine deall_var
	use pwvar, only: potch,potref
	deallocate (potch,potref)
end subroutine
!
subroutine head_cube(inunit)

	use pwvar, only: nat,pwnx,pwny,pwnz,pwdx,pwdy,pwdz

	implicit none
	integer :: inunit
	real :: d1(3),d2(3),d3(3)
	
	read(inunit,*)
	read(inunit,*)
	read(inunit,*)nat
	read(inunit,*)pwnx,d1
	read(inunit,*)pwny,d2
	read(inunit,*)pwnz,d3

	pwdx=sqrt( dot_product(d1,d1) )
	pwdy=sqrt( dot_product(d2,d2) )
	pwdz=sqrt( dot_product(d3,d3) )
	
	rewind(inunit)
	
end subroutine
!
!
subroutine tail_cube(inunit,rho)
	
	use pwvar, only: nat,pwnx,pwny,pwnz
	
	implicit none
	integer :: i,j,k
	integer :: inunit
	real, dimension (pwnx,pwny,pwnz) :: rho
	
	do i=1,nat+6
	read(inunit,*)
	enddo
	
	do i = 1, pwnx
    	do j = 1, pwny
    		read(inunit,'(6E13.5)') (rho(i,j,k),k=1,pwnz)
    	enddo
	enddo

end subroutine
