! Fourier interpolation
!
! Author: 	Giacomo Miceli
!
subroutine interpol(f,fout,nfft,npt)
	implicit none
	integer :: i,j,k
	integer :: nfft,npt
	real :: re,im, f(nfft),fout(npt)
	double complex :: infunc(nfft),outfunc(nfft)
	double complex :: newin(npt), newout(npt)
	
	integer*8 plan
	include 'fftw3.f'
	
	do i = 1, nfft
		infunc(i)= cmplx( f(i) , 0.d0 )
	enddo
	
	call dfftw_plan_dft_1d(plan,nfft,infunc,outfunc,FFTW_FORWARD,FFTW_ESTIMATE)
	call dfftw_execute_dft(plan,infunc,outfunc)
	call dfftw_destroy_plan(plan)
	
	outfunc=1.0/real(nfft)*outfunc

    do k = 1, npt
    	if (k.le.nfft / 2) then
    		newin (k) = outfunc (k)
    	elseif (k.gt.npt - nfft / 2) then
    		newin (k) = outfunc (k - npt + nfft)
   		else 
   			newin (k) = 0.d0
   		endif
	enddo
	if (mod (nfft, 2) .eq.0) then
		newin (nfft / 2 + 1) = 0.5d0 * outfunc (nfft / 2 + 1)
   		re= dreal(newin(nfft / 2 + 1))
    	im= dimag(newin(nfft / 2 + 1))
    	newin (npt - nfft / 2 + 1) = dcmplx (re,-im)
	else
    	newin (nfft / 2 + 1) = outfunc (nfft / 2 + 1)
    endif
	
	call dfftw_plan_dft_1d(plan,npt,newin,newout,FFTW_BACKWARD,FFTW_ESTIMATE)
	call dfftw_execute_dft(plan,newin,newout)
	call dfftw_destroy_plan(plan)
	
	do i = 1, npt
		fout(i)=real(newout(i))
	enddo
	  
end subroutine interpol
